diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 3572bd96..f7b96aa0 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -3,9 +3,9 @@ package services.teamwork
 
 import akka.actor.Actor
 import net.psforever.objects.Player
-import net.psforever.objects.teamwork.Squad
+import net.psforever.objects.teamwork.{Member, Squad}
 import net.psforever.packet.game._
-import net.psforever.types.PlanetSideEmpire
+import net.psforever.types.{PlanetSideEmpire, Vector3}
 import services.{GenericEventBus, Service}
 
 import scala.collection.concurrent.TrieMap
@@ -17,7 +17,7 @@ class SquadService extends Actor {
   private var memberToSquad : TrieMap[String, Squad] = new TrieMap[String, Squad]()
   private var idToSquad : TrieMap[PlanetSideGUID, Squad] = new TrieMap[PlanetSideGUID, Squad]()
   private var i : Int = 1
-  private var publishedLists : TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]] = TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]](
+  private val publishedLists : TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]] = TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]](
     PlanetSideEmpire.TR -> ListBuffer.empty,
     PlanetSideEmpire.NC -> ListBuffer.empty,
     PlanetSideEmpire.VS -> ListBuffer.empty
@@ -41,28 +41,51 @@ class SquadService extends Actor {
     PlanetSideGUID(out)
   }
 
-  def GetSquadFromPlayer(player : Player) : Squad = {
-    val name = player.Name
-    val faction = player.Faction
-    memberToSquad.get(name) match {
-      case Some(squad) =>
-        squad
+  def GetParticipatingSquad(player : Player, zone : Int) : Option[Squad] = {
+    memberToSquad.get(player.Name) match {
+      case opt @ Some(squad) =>
+        squad.Membership.find(_.Name == player.Name).get.ZoneId = zone
+        opt
       case None =>
-        val id = GetNextSquadId()
-        val squad = new Squad(id, faction)
-        val leadPosition = squad.Membership(squad.LeaderPositionIndex)
-        leadPosition.Name = name
-        leadPosition.Health = player.Health
-        leadPosition.Armor = player.Armor
-        leadPosition.Position = player.Position
-        leadPosition.ZoneId = 1 //player.Continent //TODO how to resolve this?
-        log.info(s"$name-$faction has started a new squad")
-        memberToSquad += name -> squad
-        idToSquad += id -> squad
-        squad
+        None
     }
   }
 
+  def GetLeadingSquad(player : Player, zone : Int, opt : Option[Squad]) : Squad = {
+    val name = player.Name
+    val squadOut = opt match {
+      case Some(squad) =>
+        if(squad.Leader.equals(name)) {
+          squad
+        }
+        else {
+          GetLeadingSquad(player, zone, None)
+        }
+
+      case None =>
+        memberToSquad.get(name) match {
+          case Some(squad) if squad.Leader.equals(name) =>
+            squad
+          case _ =>
+            val faction = player.Faction
+            val id = GetNextSquadId()
+            val squad = new Squad(id, faction)
+            val leadPosition = squad.Membership(squad.LeaderPositionIndex)
+            leadPosition.Name = name
+            leadPosition.Health = player.Health
+            leadPosition.Armor = player.Armor
+            leadPosition.Position = player.Position
+            leadPosition.ZoneId = zone
+            log.info(s"$name-$faction has started a new squad")
+            memberToSquad += name -> squad
+            idToSquad += id -> squad
+            squad
+        }
+    }
+    squadOut.Membership(squadOut.LeaderPositionIndex).ZoneId = zone
+    squadOut
+  }
+
   val SquadEvents = new GenericEventBus[SquadServiceResponse]
 
   def receive : Receive = {
@@ -84,167 +107,306 @@ class SquadService extends Actor {
       //check for renewable squad information
       memberToSquad.get(name) match {
         case None => ;
-        case Some(squad) =>
-          sender ! SquadServiceMessage.RecoverSquadMembership()
+        case Some(_) =>
+          sender ! SquadServiceMessage.RecoverSquadMembership() //TODO?
       }
 
     case Service.Leave(Some(name)) => ;
       SquadEvents.unsubscribe(sender())
+      memberToSquad.get(name) match {
+        case Some(squad) =>
+          if(squad.Leader.equals(name)) {
+            //we were the leader
+            if(squad.Membership.count(p => p.Name.equals("")) > 1) {
+              //other players were in the squad; publicly disband it
+              squad.Membership.foreach(position => {
+                position.Name = ""
+                position.ZoneId = 0
+                position.Position = Vector3.Zero
+                position.Health = 0
+                position.Armor = 0
+              })
+            }
+            memberToSquad.remove(name)
+            idToSquad.remove(squad.GUID)
+            UpdateSquadList(squad, List())
+          }
+          else {
+            //we were just a grunt in the squad
+            val position = squad.Membership.find(_.Name == name).get
+            position.Name = ""
+            position.ZoneId = 0
+            position.Position = Vector3.Zero
+            position.Health = 0
+            position.Armor = 0
+            UpdateSquadDetail(squad)
+          }
+        case None => ;
+      }
       //TODO leave squad, if joined to one, and perform clean-up
 
-    case Service.Leave(None) | Service.LeaveAll() =>
-      SquadEvents.unsubscribe(sender())
-      //TODO might be better to invalidate these
+    case Service.Leave(None) | Service.LeaveAll() => ;
 
-    case SquadServiceMessage.SquadDefinitionAction(tplayer, zone_ordinal_number, _, _, action) =>
+    case SquadServiceMessage.SquadDefinitionAction(tplayer, zone_ordinal_number, guid, _, action) =>
       import net.psforever.packet.game.SquadAction._
-      val squad = GetSquadFromPlayer(tplayer)
-      val member = squad.Membership.find(_.Name == tplayer.Name).get //should never fail
-      member.ZoneId = zone_ordinal_number //TODO improve this requirement
-      if(tplayer.Name.equals(squad.Leader)) {
-        var listingChanged : List[Int] = Nil
-        action match {
-          case ChangeSquadPurpose(purpose) =>
-            log.info(s"${tplayer.Name}-${tplayer.Faction} has changed his squad's task to $purpose")
-            squad.Description = purpose
-            listingChanged = List(SquadInfo.Field.Task)
+      val squadOpt = GetParticipatingSquad(tplayer, zone_ordinal_number)
+      action match {
+        case ChangeSquadPurpose(purpose) =>
+          log.info(s"${tplayer.Name}-${tplayer.Faction} has changed his squad's task to $purpose")
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          squad.Task = purpose
+          UpdateSquadList(squad, List(SquadInfo.Field.Task))
+          UpdateSquadDetail(squad)
 
-          case ChangeSquadZone(zone) =>
-            log.info(s"${tplayer.Name}-${tplayer.Faction} has changed his squad's ops zone to $zone")
-            squad.ZoneId = zone.zoneId.toInt
-            listingChanged = List(SquadInfo.Field.ZoneId)
+        case ChangeSquadZone(zone) =>
+          log.info(s"${tplayer.Name}-${tplayer.Faction} has changed squad's ops zone to $zone")
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          squad.ZoneId = zone.zoneId.toInt
+          UpdateSquadList(squad, List(SquadInfo.Field.ZoneId))
+          UpdateSquadDetail(squad)
 
-          case CloseSquadMemberPosition(position) =>
-            if(position != squad.LeaderPositionIndex) {
-              squad.Availability.lift(position) match {
-                case Some(true) =>
-                  squad.Availability.update(position, false)
-                  log.info(s"${tplayer.Name}-${tplayer.Faction} has closed the #$position position in his squad")
-                  val memberPosition = squad.Membership(position)
-                  listingChanged = if(memberPosition.Name.nonEmpty) {
-                    List(SquadInfo.Field.Size, SquadInfo.Field.Capacity)
+        case CloseSquadMemberPosition(position) =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          squad.Availability.lift(position) match {
+            case Some(true) =>
+              squad.Availability.update(position, false)
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has closed the #$position position in squad")
+              val memberPosition = squad.Membership(position)
+              val listingChanged = if(memberPosition.Name.nonEmpty) {
+                List(SquadInfo.Field.Size, SquadInfo.Field.Capacity)
+              }
+              else {
+                List(SquadInfo.Field.Capacity)
+              }
+              memberPosition.Close()
+              UpdateSquadList(squad, listingChanged)
+              UpdateSquadDetail(squad)
+            case Some(false) | None => ;
+          }
+
+        case AddSquadMemberPosition(position) =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          squad.Availability.lift(position) match {
+            case Some(false) =>
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has opened the #$position position in squad")
+              squad.Availability.update(position, true)
+              UpdateSquadList(squad, List(SquadInfo.Field.Capacity))
+              UpdateSquadDetail(squad)
+            case Some(true) | None => ;
+          }
+
+        case ChangeSquadMemberRequirementsRole(position, role) =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          squad.Availability.lift(position) match {
+            case Some(true) =>
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the role of squad position #$position")
+              squad.Membership(position).Role = role
+              UpdateSquadDetail(squad)
+            case Some(false) | None => ;
+          }
+
+        case ChangeSquadMemberRequirementsDetailedOrders(position, orders) =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          squad.Availability.lift(position) match {
+            case Some(true) =>
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the orders for squad position #$position")
+              squad.Membership(position).Orders = orders
+              UpdateSquadDetail(squad)
+            case Some(false) | None => ;
+          }
+
+        case ChangeSquadMemberRequirementsCertifications(position, certs) =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          squad.Availability.lift(position) match {
+            case Some(true) =>
+              log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the requirements for squad position #$position")
+              squad.Membership(position).Requirements = certs
+              UpdateSquadDetail(squad)
+            case Some(false) | None => ;
+          }
+
+        case LocationFollowsSquadLead(state) =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          if(state) {
+            log.info(s"${tplayer.Name}-${tplayer.Faction} has moves the rally to the leader's position")
+          }
+          else {
+            log.info(s"${tplayer.Name}-${tplayer.Faction} has let the rally move freely")
+          }
+          squad.LocationFollowsSquadLead = state
+
+        case AutoApproveInvitationRequests(state) =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          if(state) {
+            log.info(s"${tplayer.Name}-${tplayer.Faction} is allowing all requests to join the squad")
+          }
+          else {
+            log.info(s"${tplayer.Name}-${tplayer.Faction} has started screening invitation requests")
+          }
+          squad.AutoApproveInvitationRequests = state
+
+        case SelectRoleForYourself(line) =>
+          //TODO need to ask permission from the squad leader, unless our character is the squad leader or already currently in the squad
+          val name = tplayer.Name
+          squadOpt match {
+            case Some(squad) =>
+              {
+                if(squad.Availability(line))
+                  squad.Membership.lift(line)
+                else
+                  None
+              } match {
+                case Some(desiredPosition : Member)
+                  if desiredPosition.Requirements.intersect(tplayer.Certifications) == desiredPosition.Requirements =>
+                  //our character is qualified for this new position
+                  if(squad.Leader.equals(tplayer.Name)) {
+                    squad.LeaderPositionIndex = line //update
                   }
-                  else {
-                    List(SquadInfo.Field.Capacity)
+                  val hadPreviousPosition = squad.Membership.find(_.Name == name) match {
+                    case Some(currentPosition)=>
+                      currentPosition.Name = ""
+                      currentPosition.ZoneId = 0
+                      currentPosition.Health = 0
+                      currentPosition.Armor = 0
+                      currentPosition.Position = Vector3.Zero
+                      true
+                    case None =>
+                      false
                   }
-                  memberPosition.Close()
-                case Some(false) => ;
+                  desiredPosition.Name = name
+                  desiredPosition.ZoneId = zone_ordinal_number
+                  desiredPosition.Health = tplayer.Health
+                  desiredPosition.Armor = tplayer.Armor
+                  desiredPosition.Position = tplayer.Position
+                  if(!hadPreviousPosition) {
+                    UpdateSquadList(squad, List(SquadInfo.Field.Size))
+                  }
+                  UpdateSquadDetail(squad)
                 case None => ;
               }
-            }
-            else {
-              log.warn(s"can not close the leader position in squad-${squad.GUID.guid}")
-            }
 
-          case AddSquadMemberPosition(position) =>
-            squad.Availability.lift(position) match {
-              case Some(false) =>
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has opened the #$position position in his squad")
-                squad.Availability.update(position, true)
-                listingChanged = List(SquadInfo.Field.Capacity)
-              case Some(true) => ;
-              case None => ;
-            }
-
-          case ChangeSquadMemberRequirementsRole(position, role) =>
-            squad.Availability.lift(position) match {
-              case Some(true) =>
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the role of squad position #$position")
-                squad.Membership(position).Role = role
-              case Some(false) => ;
-              case None => ;
-            }
-
-          case ChangeSquadMemberRequirementsDetailedOrders(position, orders) =>
-            squad.Availability.lift(position) match {
-              case Some(true) =>
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the orders for squad position #$position")
-                squad.Membership(position).Orders = orders
-              case Some(false) => ;
-              case None => ;
-            }
-
-          case ChangeSquadMemberRequirementsCertifications(position, certs) =>
-            squad.Availability.lift(position) match {
-              case Some(true) =>
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the requirements for squad position #$position")
-                squad.Membership(position).Requirements = certs
-              case Some(false) => ;
-              case None => ;
-            }
-
-          case ListSquad() =>
-            if(!squad.Listed) {
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has opened recruitment for his squad")
-              squad.Listed = true
-            }
-
-          case ResetAll() =>
-            squad.Description = ""
-            squad.ZoneId = None
-            squad.Availability.indices.foreach { i =>
-              squad.Availability.update(i, true)
-            }
-          //TODO squad members?
-
-          case _ => ;
-        }
-        //queue updates
-        if(squad.Listed) {
-          val entry = SquadService.Publish(squad)
-          val faction = squad.Faction
-          val factionListings = publishedLists(faction)
-          factionListings.find(info => {
-            info.squad_guid match {
-              case Some(guid) => guid == squad.GUID
-              case _ => false
-            }
-          }) match {
-            case Some(listedSquad) =>
-              val index = factionListings.indexOf(listedSquad)
-              val changes = if(listingChanged.nonEmpty) {
-                SquadService.Differences(listingChanged, entry)
-              }
-              else {
-                SquadService.Differences(listedSquad, entry)
-              }
-              if(changes != SquadInfo.Blank) {
-                //squad information update
-                log.info(s"Squad will be updated")
-                factionListings(index) = entry
-                SquadEvents.publish(
-                  SquadServiceResponse(s"$faction/Squad", SquadResponse.Update(Seq((index, changes))))
-                )
-              }
-              else {
-                //remove squad from listing
-                log.info(s"Squad will be removed")
-                factionListings.remove(index)
-                SquadEvents.publish(
-                  SquadServiceResponse(s"$faction/Squad", SquadResponse.Remove(Seq(index)))
-                )
-              }
-            case None =>
-              //first time being published
-              log.info(s"Squad will be introduced")
-              factionListings += SquadService.Publish(squad)
-              SquadEvents.publish(
-                SquadServiceResponse(s"$faction/Squad", SquadResponse.Init(factionListings.toVector))
-              )
+            case None => ;
           }
-        }
+
+        case ListSquad() =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          if(!squad.Listed) {
+            log.info(s"${tplayer.Name}-${tplayer.Faction} has opened recruitment for this squad")
+            squad.Listed = true
+          }
+          UpdateSquadList(squad, List())
+
+        case ResetAll() =>
+          val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+          squad.Task = ""
+          squad.ZoneId = None
+          squad.Availability.indices.foreach { i =>
+            squad.Availability.update(i, true)
+          }
+          squad.Membership.foreach(position => {
+            position.Role = ""
+            position.Orders = ""
+            position.Requirements = Set()
+          })
+          UpdateSquadList(squad, List(SquadInfo.Field.Task, SquadInfo.Field.ZoneId, SquadInfo.Field.Size, SquadInfo.Field.Capacity))
+          UpdateSquadDetail(squad)
+
+        case DisplaySquad() =>
+          idToSquad.get(guid) match {
+            case Some(squad) =>
+              sender ! SquadServiceResponse(s"${tplayer.Name}/Squad", GenSquadDetail(squad))
+            case None => ;
+          }
+
+        case _ => ;
       }
 
     case msg =>
       log.info(s"Unhandled message $msg from $sender")
   }
+
+  def UpdateSquadList(squad : Squad, listingChanged : List[Int]) : Unit = {
+    //queue updates
+    if(squad.Listed) {
+      val entry = SquadService.Publish(squad)
+      val faction = squad.Faction
+      val factionListings = publishedLists(faction)
+      factionListings.find(info => {
+        info.squad_guid match {
+          case Some(sguid) => sguid == squad.GUID
+          case _ => false
+        }
+      }) match {
+        case Some(listedSquad) =>
+          val index = factionListings.indexOf(listedSquad)
+          val changes = if(listingChanged.nonEmpty) {
+            SquadService.Differences(listingChanged, entry)
+          }
+          else {
+            SquadService.Differences(listedSquad, entry)
+          }
+          if(changes != SquadInfo.Blank) {
+            //squad information update
+            log.info(s"Squad will be updated")
+            factionListings(index) = entry
+            SquadEvents.publish(
+              SquadServiceResponse(s"$faction/Squad", SquadResponse.Update(Seq((index, changes))))
+            )
+          }
+          else {
+            //remove squad from listing
+            log.info(s"Squad will be removed")
+            factionListings.remove(index)
+            SquadEvents.publish(
+              SquadServiceResponse(s"$faction/Squad", SquadResponse.Remove(Seq(index)))
+            )
+          }
+        case None =>
+          //first time being published
+          log.info(s"Squad will be introduced")
+          factionListings += SquadService.Publish(squad)
+          SquadEvents.publish(
+            SquadServiceResponse(s"$faction/Squad", SquadResponse.Init(factionListings.toVector))
+          )
+      }
+    }
+  }
+
+  def GenSquadDetail(squad : Squad) : SquadResponse.Detail = {
+    SquadResponse.Detail(
+      squad.GUID,
+      squad.Leader,
+      squad.Task,
+      PlanetSideZoneID(squad.ZoneId),
+      squad.Membership.zipWithIndex.map({ case (p, index) =>
+        if(squad.Availability(index)) {
+          SquadPositionDetail(p.Role, p.Orders, p.Requirements, p.Name)
+        }
+        else {
+          SquadPositionDetail.Closed
+        }
+      }).toList
+    )
+  }
+
+  def UpdateSquadDetail(squad : Squad) : Unit = {
+    val detail = GenSquadDetail(squad)
+    squad.Membership.collect {
+      case member if !member.Name.equals("") =>
+        member.Name
+    }.foreach { name =>
+      SquadEvents.publish(
+        SquadServiceResponse(s"$name/Squad", detail)
+      )
+    }
+  }
 }
 
 object SquadService {
   def Publish(squad : Squad) : SquadInfo = {
     SquadInfo(
       squad.Leader,
-      squad.Description,
+      squad.Task,
       PlanetSideZoneID(squad.ZoneId),
       squad.Size,
       squad.Capacity,
diff --git a/common/src/main/scala/services/teamwork/SquadServiceMessage.scala b/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
index 5f918787..2157d44c 100644
--- a/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
+++ b/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
@@ -2,12 +2,12 @@
 package services.teamwork
 
 import net.psforever.objects.Player
-import net.psforever.packet.game.SquadAction
+import net.psforever.packet.game.{PlanetSideGUID, SquadAction}
 
 final case class SquadServiceMessage(forChannel : String, actionMessage : Any)
 
 object SquadServiceMessage {
-  final case class SquadDefinitionAction(player : Player, zone_ordinal_number : Int, u1 : Int, u2 : Int, action : SquadAction)
+  final case class SquadDefinitionAction(player : Player, zone_ordinal_number : Int, guid : PlanetSideGUID, line : Int, action : SquadAction)
 
   final case class RecoverSquadMembership()
 }
